/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3ChangePilot
{
	Connection conn;
	Assignment3 a3;
	
	// constructor
	TestAssignment3ChangePilot()
	{
		conn = null;
		try{
		a3 = new Assignment3();
		}catch(Exception s)
		{	
			System.out.println("Error");
		}
	}

	public static void main(String args[])
	{
		// check for number of arguments
		if ( args.length < 2 || args.length > 3 )
		{
			System.out.println("Usage: java TestAssignment3 dbname " + 
					"username [password]");
			System.exit(1);
		}

		TestAssignment3ChangePilot ta3 = new TestAssignment3ChangePilot();

		boolean status = false; 
		
		System.out.println("-----------------------------------------------");
		System.out.println("           Test Change Pilot Method            ");
		System.out.println("-----------------------------------------------");
		
		try{
			
			// test all methods one at a time
			if(args.length==3)
			    status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
			    status = ta3.TestconnectDB(args[0],args[1],null);
			
		}catch(Exception e){
			System.out.println("Error testing connectDB() "+ e.toString());
		}
		

		try{
		status = ta3.TestchangePilot();		
		System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
		
		if(status){
			TestAssignment3ScoreKeeper.setScoreStatus(4, 3, status);
			//ta3.scores[4] = 3;
		}
		}catch(Exception e){
			System.out.println("Error testing changePilot() "+ e.toString());
		}
		
		try{
			status = ta3.TestdisconnectDB();
	
		}catch(Exception e){
			System.out.println("Error testing disconnectDB() "+ e.toString());
		}
	}

	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			//System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			boolean success = a3.connectDB(url, username, password);
			return success;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		try{
			boolean success = a3.disconnectDB();
			return success;

		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}

		return false;
	}
	
	
	
	
	// This method compares output against hard coded values
	boolean TestchangePilot()
	{
		try{

		System.out.println("-----------------------------------------------");
		System.out.println("-----------------------------------------------");
		System.out.println("Testing changePilot() method...");
		
		Statement stmt = null;
		ResultSet rs = null;
		int count = 0;
		int count1 = 0;
		float totalScore = 3.0F;
		
		//change the pilot 113 from AC to pilot 115 from AL
		//and the plane type is 2, so 105 can flight, so the new 
		//record in the flightImplementation will be 
		//"AL", 1002, "2000-02-08", 115, 3
		System.out.println("Testing changePilot('AC', 1002, 113, 105), the resulting record should be ('AC', 1002, '2008-04-08', 105, 3) and ('AC', 1002, '2008-05-08', 105, 3), and return value should be 2");
		int retval = a3.changePilot("AC", 1002, 113, 105);
		System.out.println("Return Value: " + retval);

		stmt = conn.createStatement();
		String queryString = "select count(*) from flightImplementation where company = 'AC' and flightNo = 1002 and mainPilot = 105 and plane = 3";
		rs = stmt.executeQuery(queryString);

		if ( rs.next() )
			count = rs.getInt(1);
		
		System.out.println("Two records with flightNo 1002 should be changed, the actual change is " + count + " number of records");
		if(count != 2) totalScore -= 2.0F;
		
		System.out.println("Testing changePilot('AC', 1002, 105, 115), date is ok, but pilot is not qualified, so return value should be 0");
		int retval1 = a3.changePilot("AC", 1002, 105, 115);
		System.out.println("Return Value: " + retval1);
		
		if(retval1 != 0) totalScore -= 0.5F;
		
		//this one test if the the change is valid, but date is not valid, so it shouldn't change 
		System.out.println("Testing changePilot('LU', 1005, 107, 115), nothing should be changed, and return value should be 0");
		int retval2 = a3.changePilot("LU", 1005, 107, 115);
		System.out.println("Return Value: " + retval2);

		if(retval2 != 0) totalScore -= 0.5F;
		
		
		
		if (count == 2 && retval == 1 && retval1==0 && retval2==0)
			return true;
		else{
			TestAssignment3ScoreKeeper.setScore(4, totalScore);
			return false;
		}

		}catch(SQLException se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}
		return false;
	}
	
}	
