/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3Connections
{
	Connection conn;
	Assignment3 a3;
	
	// constructor
	TestAssignment3Connections()
	{
		conn = null;
		try{
		a3 = new Assignment3();
		}catch(Exception s)
		{	
			System.out.println("Error");
		}
		
	}

	public static void main(String args[])
	{
		// check for number of arguments
		if ( args.length < 2 || args.length > 3 )
		{
			System.out.println("Usage: java TestAssignment3 dbname " + 
					"username [password]");
			System.exit(1);
		}

		TestAssignment3Connections ta3 = new TestAssignment3Connections();

		boolean status = false; 
		
		System.out.println("-----------------------------------------------");
		System.out.println("           Test Connections Method            ");
		System.out.println("-----------------------------------------------");
		
		try{
			
			// test all methods one at a time
			if(args.length==3)
			    status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
			    status = ta3.TestconnectDB(args[0],args[1],null);
			
			if(status){
				TestAssignment3ScoreKeeper.setScoreStatus(0, 1, status);
			}
			else{
				TestAssignment3ScoreKeeper.setScoreStatus(0, 0, status);
			}
	
			System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
		}catch(Exception e){
			System.out.println("Error testing connectDB() "+ e.toString());
		}
		

		try{
		status = ta3.TestdisconnectDB();
		System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
		
		if(status){
			TestAssignment3ScoreKeeper.setScoreStatus(7, 1, status);
			//ta3.scores[7] = 1;
		}
		else{
			TestAssignment3ScoreKeeper.setScoreStatus(7, 0, status);
		}
		
		}catch(Exception e){
			System.out.println("Error testing disconnectDB() "+ e.toString());
		}
	}

	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			System.out.println("-----------------------------------------------");
			System.out.println("-----------------------------------------------");
			System.out.println("Testing connectDB() method...");
			boolean success = a3.connectDB(url, username, password);
			System.out.println("Return Value: " + success);

			if ( success == true )
				return true;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		System.out.println("---------------------------------------------");
		System.out.println("-----------------------------------------------");
		System.out.println("Testing disconnectDB() method...");
		try{
		boolean success = a3.disconnectDB();
		System.out.println("Return Value: " + success);

		if ( success == true )
			return true;
		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}
		

		return false;
	}
	
	
	
}	
