/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3DelayFlights {
	Connection conn;
	Assignment3 a3;

	// constructor
	TestAssignment3DelayFlights() {
		conn = null;
		try {
			a3 = new Assignment3();
		} catch (Exception s) {
			System.out.println("Error");
		}

	}

	public static void main(String args[]) {
		// check for number of arguments
		if (args.length < 2 || args.length > 3) {
			System.out.println("Usage: java TestAssignment3 dbname "
					+ "username [password]");
			System.exit(1);
		}

		TestAssignment3DelayFlights ta3 = new TestAssignment3DelayFlights();

		boolean status = false;

		System.out.println("-----------------------------------------------");
		System.out.println("           Test Delay Flights Method            ");
		System.out.println("-----------------------------------------------");

		try {

			// test all methods one at a time
			if (args.length == 3)
				status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
				status = ta3.TestconnectDB(args[0], args[1], null);

		} catch (Exception e) {
			System.out.println("Error testing connectDB() " + e.toString());
		}

		try {
			status = ta3.TestdelayFlights();
			System.out.println("\nOverall Test Status: "
					+ TestAssignment3ScoreKeeper.getTestStatus(status));

			if (status) {
				TestAssignment3ScoreKeeper.setScoreStatus(6, 3, status);
				// ta3.scores[4] = 3;
			}
		} catch (Exception e) {
			System.out.println("Error testing delayFlights() " + e.toString());
		}

		try {
			
			status = ta3.TestdisconnectDB();
			
		} catch (Exception e) {
			System.out.println("Error testing disconnectDB() " + e.toString());
		}
	}
	
	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			//System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			boolean success = a3.connectDB(url, username, password);
			return success;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		try{
			boolean success = a3.disconnectDB();
			return success;

		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}

		return false;
	}


	// This method compares output against hard coded values
	boolean TestdelayFlights() {
		try {
			System.out
					.println("-----------------------------------------------");
			System.out
					.println("-----------------------------------------------");
			System.out.println("Testing delayFlights() method...");
			System.out
					.println("Testing delayFlights with ('LU', 'YYZ', 8, 20), return value should 1");
			int retval = a3.delayFlights("LU", "YYZ", 8, 20);
			System.out.println("Return Value: " + retval);

			// insert into flight values('LU', 1005, '17:32', '19:33', 'YYZ',
			// 'YYY');

			// verify from database directly
			Statement stmt = null;
			ResultSet rs = null;
			int count = 0;
			String queryString;

			// verify total no of rows and newly inserted from department table
			stmt = conn.createStatement();
			queryString = "select count(*) from flight where flightNo=1005 and departTime='23:59' and arrivalTime='02:00'";
			rs = stmt.executeQuery(queryString);

			if (rs.next())
				count = rs.getInt(1);

			System.out.println("One record should be changed. There are "
					+ count + " records have been changed.");

			System.out
					.println("Testing delayFlights with ('AC', 'JKW', 1, 8), return value should 2");
			int retval1 = a3.delayFlights("AC", "JKW", 1, 8);
			System.out.println("Return Value: " + retval1);

			rs = null;
			count = 0;

			queryString = "select count(*) from flight where flightNo=1003 and departTime='07:51' and arrivalTime='22:19'";
			rs = stmt.executeQuery(queryString);

			if (rs.next())
				count = rs.getInt(1);

			queryString = "select count(*) from flight where flightNo=1008 and departTime='23:58' and arrivalTime='00:27'";
			rs = stmt.executeQuery(queryString);

			if (rs.next())
				count += rs.getInt(1);

			System.out.println("Two records should be changed. There are "
					+ count + " records have been changed.");

			count = 0;

			System.out
					.println("Testing delayFlights with ('AC', 'JKW', 2, 8), return value should 2");
			int retval2 = a3.delayFlights("AC", "JKW", 2, 8);
			System.out.println("Return Value: " + retval2);

			queryString = "select count(*) from flight where flightNo=1003 and departTime='09:59' and arrivalTime='00:27'";
			rs = stmt.executeQuery(queryString);

			if (rs.next())
				count = rs.getInt(1);

			queryString = "select count(*) from flight where flightNo=1008 and departTime='02:06' and arrivalTime='02:35'";
			rs = stmt.executeQuery(queryString);

			if (rs.next())
				count += rs.getInt(1);

			System.out.println("Two records should be changed. There are "
					+ count + " records have been changed.");

			if (retval == 1 && retval1 == 2 && retval2 == 2)
				return true;
			else {
				float totalScore = 0.0f;
				if(retval == 1) totalScore = 1.0F;
				if(retval1 == 2) totalScore+= 1.0F;
				if(retval2 == 2) totalScore+= 1.0F;
				TestAssignment3ScoreKeeper.setScore(6, totalScore);
				return false;
			}

		} catch (SQLException se) {
			System.err.println("SQL Exception in main(). " + "<Message>: "
					+ se.getMessage());
		}
		return true;
	}

}
