/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3DeleteFlight
{
	Connection conn;
	Assignment3 a3;
	
	// constructor
	TestAssignment3DeleteFlight()
	{
		conn = null;
		try{
		a3 = new Assignment3();
		}catch(Exception s)
		{	
			System.out.println("Error");
		}
		
	}

	public static void main(String args[])
	{
		// check for number of arguments
		if ( args.length < 2 || args.length > 3 )
		{
			System.out.println("Usage: java TestAssignment3 dbname " + 
					"username [password]");
			System.exit(1);
		}

		TestAssignment3DeleteFlight ta3 = new TestAssignment3DeleteFlight();

		boolean status = false; 
		
		System.out.println("-----------------------------------------------");
		System.out.println("           Test Delete Flight Method          ");
		System.out.println("-----------------------------------------------");
		
		try{
			
			// test all methods one at a time
			if(args.length==3)
			    status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
			    status = ta3.TestconnectDB(args[0],args[1],null);
			
		}catch(Exception e){
			System.out.println("Error testing connectDB() "+ e.toString());
		}
		
		try{
			status = ta3.TestdeleteFlight();		
			System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
			
			if(status){
				TestAssignment3ScoreKeeper.setScoreStatus(5, 2, status);
				//ta3.scores[4] = 3;
			}
			}catch(Exception e){
				System.out.println("Error testing deleteFlight() "+ e.toString());
			}
		
		try{
			status = ta3.TestdisconnectDB();
		}catch(Exception e){
			System.out.println("Error testing disconnectDB() "+ e.toString());
		}
	}
	
	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			//System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			boolean success = a3.connectDB(url, username, password);
			return success;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		try{
			boolean success = a3.disconnectDB();
			return success;

		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}

		return false;
	}

		
	boolean TestdeleteFlight()
	{
		try 
		{
			System.out.println("-----------------------------------------------");
			System.out.println("-----------------------------------------------");
			System.out.println("Testing deleteFlight() method...");
			System.out.println("Deleting record ('OL', 1000, '19990108')");

			int noOfRecords1 = a3.deleteFlight("OL", 1000, "19990108");

			System.out.println("Return Value: " + noOfRecords1 + ". It should be 1.");

			System.out.println("Deleting record ('AL', 1007, '19990608')");

			int noOfRecords2 = a3.deleteFlight("AL", 1007, "19990608");

			System.out.println("Return Value: " + noOfRecords2 + ". It should be 1.");

			// verify from database directly
			Statement stmt = null;
			ResultSet rs = null;
			int flight_count = 0;
			int count = 0;
			int count1 = 0;
			String queryString;

			// verify total no of rows and newly inserted from department table
			stmt = conn.createStatement();
			queryString = "select count(*) from flightImplementation";
			rs = stmt.executeQuery(queryString);

			if ( rs.next() )
				flight_count = rs.getInt(1);

			queryString = "select count(*) from flightImplementation where " +
					" flightNo = 1000";
			rs = stmt.executeQuery(queryString);

			if ( rs.next() )
				count = rs.getInt(1);
			
			System.out.println("Flight 1000 is deleted: "+ (count == 0));
			
			queryString = "select count(*) from flightImplementation where " +
			" flightNo = 1007";
			rs = stmt.executeQuery(queryString);

			if ( rs.next() )
				count1 = rs.getInt(1);
			
			System.out.println("Flight 1007 is deleted: "+ (count1 == 0));
			
			System.out.println("The number of remaining flights are: "+ flight_count + ". It should be 9 records.");

			if (noOfRecords1 == 1 && noOfRecords2 == 1 && flight_count == 9 && count == 0 && count1 == 0)
				return true;
			else{
				TestAssignment3ScoreKeeper.setScore(5, 0F);
				return false;
			}
		}
		catch (SQLException se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}
		return false;
	}
	
	
}	
