/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3GetCityCrew
{
	Connection conn;
	Assignment3 a3;
	
	// constructor
	TestAssignment3GetCityCrew()
	{
		conn = null;
		try{
		a3 = new Assignment3();
		}catch(Exception s)
		{	
			System.out.println("Error");
		}
		
	}

	public static void main(String args[])
	{
		// check for number of arguments
		if ( args.length < 2 || args.length > 3 )
		{
			System.out.println("Usage: java TestAssignment3 dbname " + 
					"username [password]");
			System.exit(1);
		}

		TestAssignment3GetCityCrew ta3 = new TestAssignment3GetCityCrew();

		boolean status = false; 
		
		System.out.println("-----------------------------------------------");
		System.out.println("           Test Get City Crew Method            ");
		System.out.println("-----------------------------------------------");
		
		try{
			
			// test all methods one at a time
			if(args.length==3)
			    status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
			    status = ta3.TestconnectDB(args[0],args[1],null);
			
		}catch(Exception e){
			System.out.println("Error testing connectDB() "+ e.toString());
		}
		
		try{
			status = ta3.TestgetCityCrew();		
			System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
			
			if(status){
				TestAssignment3ScoreKeeper.setScoreStatus(3, 2, status);
				//ta3.scores[4] = 3;
			}
			}catch(Exception e){
				System.out.println("Error testing getCityCrew() "+ e.toString());
			}
	
		
		try{
			status = ta3.TestdisconnectDB();
		
		}catch(Exception e){
			System.out.println("Error testing disconnectDB() "+ e.toString());
		}
	}
	
	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			//System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			boolean success = a3.connectDB(url, username, password);
			return success;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		try{
			boolean success = a3.disconnectDB();
			return success;

		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}

		return false;
	}

		
	/**
	 * The ground accommodation planners need to know who will be flying into
	 * their city, and when they will be arriving so that they can make ground
	 * arrangements (hotel and limo) for them.
	 * Return a list of all crew who are flying into the city identified by the three character
	 * apid (AirportID) on the date specified for the company
	 * specified. The crew must include the main pilot as well as all other crew.
	 * Include the following information for each row:
	 * <flight number>:<arrival time>:<last name>:<first name>
	 * Remember to separate rows with the # symbol. Order your list by first name
	 * within last name within arrival time in ascending order.
	 * @param date
	 * @param company
	 * @param AirportID
	 * @return
	 */
	boolean TestgetCityCrew()
	{
		try{
			float totalScore = 0.0F;
			//String date, String company, String AirportID
			System.out.println("-----------------------------------------------");
			System.out.println("-----------------------------------------------");
			System.out.println("Testing getCityCrew() method...");
			System.out.println("");

			String info1 = a3.getCityCrew("19990108", "OL", "YYY");
			String correctAnswer1 = "1000:02:23:00:Agopoulos:Cleo#1000:02:23:00:Brown:Robert#1000:02:23:00:Smith:Susan";
			System.out.println("Correct answer is " + correctAnswer1);
			System.out.println("Return value: \n" + info1);
			if(info1.trim().equalsIgnoreCase(correctAnswer1)){
				totalScore += 0.5F;
			}
			String info2 = a3.getCityCrew("19990408", "LU", "ABC");
			String correctAnswer2 = "1006:23:21:00:Flemming:Sandford#1006:23:21:00:Muhler:Ulrich";
			System.out.println("Correct answer is " + correctAnswer2);
			System.out.println("Return value: \n" + info2);
			if(info2.trim().equalsIgnoreCase(correctAnswer2)){
				totalScore += 0.5F;
			}
			String correctAnswer3 = "1008:23:19:00:Flemming:Sandford";
			System.out.println("Correct answer is " + correctAnswer3);
			String info3 = a3.getCityCrew("19990711", "AC", "ABC");
			if(info3.trim().equalsIgnoreCase(correctAnswer3)){
				totalScore += 0.5F;
			}
			String correctAnswer4 = "";
			System.out.println("Return value: \n" + info3);
			System.out.println("Correct answer is empty");
			String info4 = a3.getCityCrew("19990308", "OL", "JKW");
			System.out.println("Return value: \n" + info4);
			if(info4.trim().equalsIgnoreCase(correctAnswer4)){
				totalScore += 0.5F;
			}
				
			if(totalScore == 2.0F) return true;
			
			else{ 
				TestAssignment3ScoreKeeper.setScore(3, totalScore);
				return false;
			}
				
			//System.out.println("\nCorrect Value: \n" + "Homer:Simpson:M:45:4:Computer Science");

			//if (info.indexOf("Homer") != -1 && info.indexOf("Simpson") != -1 && info.indexOf("Computer Science") != -1)
			//	return true;

		}catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}
		return false;
	}	
	

	
}	
