/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3GetLanguageCount
{
	Connection conn;
	Assignment3 a3;
	
	// constructor
	TestAssignment3GetLanguageCount()
	{
		conn = null;
		try{
		a3 = new Assignment3();
		}catch(Exception s)
		{	
			System.out.println("Error");
		}
	}

	public static void main(String args[])
	{
		// check for number of arguments
		if ( args.length < 2 || args.length > 3 )
		{
			System.out.println("Usage: java TestAssignment3 dbname " + 
					"username [password]");
			System.exit(1);
		}

		TestAssignment3GetLanguageCount ta3 = new TestAssignment3GetLanguageCount();

		boolean status = false; 
		
		System.out.println("-----------------------------------------------");
		System.out.println("           Test Get Language Count Method            ");
		System.out.println("-----------------------------------------------");
		
		try{
			
			// test all methods one at a time
			if(args.length==3)
			    status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
			    status = ta3.TestconnectDB(args[0],args[1],null);
			
		}catch(Exception e){
			System.out.println("Error testing connectDB() "+ e.toString());
		}
		
		try{
			status = ta3.TestgetLanguageCount();		
			System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
			
			if(status){
				TestAssignment3ScoreKeeper.setScoreStatus(2, 2, status);
				//ta3.scores[4] = 3;
			}
			}catch(Exception e){
				System.out.println("Error testing getLanguageCount() "+ e.toString());
			}
	
		
		try{
			status = ta3.TestdisconnectDB();
		}catch(Exception e){
			System.out.println("Error testing disconnectDB() "+ e.toString());
		}
	}
	
	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			//System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			boolean success = a3.connectDB(url, username, password);
			return success;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		try{
			boolean success = a3.disconnectDB();
			return success;

		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}

		return false;
	}
	
	/**
	 * What I need to do here is first print out the correct result for language count,
	 * then I will print out the results from the student, and use that to compare them. 
	 * @return
	 */
	boolean TestgetLanguageCount()
	{
		try{
			System.out.println("------------------------------------------------");
			System.out.println("------------------------------------------------");
			System.out.println("Testing getLanguageCount() method...");
			System.out.println("Format is AA:English:24#AC:Chinese:4#AC:English:7#AC:French:5");
			
			String correctAnswer = "AC:French:1#AC:Greek:1#AF:English:1#AI:English:1#AI:Italian:1#AL:English:2#LU:English:1#LU:Indian:1#OL:English:2#OL:GERMAN:1#OL:Greek:1";
			System.out.println("The correct answer is " + correctAnswer);
			String languageCountString = a3.getLanguageCount();
			System.out.println("Return value: " + languageCountString);
			
			if(correctAnswer.trim().equalsIgnoreCase(languageCountString.trim())){
				return true;
			}
			else{
				TestAssignment3ScoreKeeper.setScore(2, 0.0f);
			}
			
		}catch (Exception se)
		{
			System.err.println("Exception in main(). " +
					"<Message>: " + se.getMessage());
		}
		return false;
	}
	
	
}	
