/* 
 * FILES:	TestAssignment3.java 
 * CLASSNAME: 	TestAssignment3
 * DESCRIPTION: Test driver for testing JDBC part of CSC343 Assignment3 (JDBC part)
 * MISC:	1) Assumes that classpath is configured to 
 * 		   include postgresql driver
 */

import java.sql.*;
import java.util.Vector;

public class TestAssignment3InsertImplement
{
	Connection conn;
	Assignment3 a3;
	
	// constructor
	TestAssignment3InsertImplement()
	{
		conn = null;
		try{
		a3 = new Assignment3();
		}catch(Exception s)
		{	
			System.out.println("Error");
		}
		
	}

	public static void main(String args[])
	{
		// check for number of arguments
		if ( args.length < 2 || args.length > 3 )
		{
			System.out.println("Usage: java TestAssignment3 dbname " + 
					"username [password]");
			System.exit(1);
		}

		TestAssignment3InsertImplement ta3 = new TestAssignment3InsertImplement();

		boolean status = false; 
		
		System.out.println("-----------------------------------------------");
		System.out.println("           Test Insert Implement Method            ");
		System.out.println("-----------------------------------------------");
		
		try{
			
			// test all methods one at a time
			if(args.length==3)
			    status = ta3.TestconnectDB(args[0], args[1], args[2]);
			else
			    status = ta3.TestconnectDB(args[0],args[1],null);
			
		}catch(Exception e){
			System.out.println("Error testing connectDB() "+ e.toString());
		}
		

		try{
			status = ta3.TestinsertImplement();		
			System.out.println("\nOverall Test Status: " + TestAssignment3ScoreKeeper.getTestStatus(status));
			
			if(status){
				TestAssignment3ScoreKeeper.setScoreStatus(1, 3, status);
				//ta3.scores[4] = 3;
			}
			
			}catch(Exception e){
				System.out.println("Error testing insertImplment() "+ e.toString());
			}
		
		try{
			status = ta3.TestdisconnectDB();
		}catch(Exception e){
			System.out.println("Error testing disconnectDB() "+ e.toString());
		}
	}
	
	/**
	 * This method is something I can keep. However, the first variable here should be URL 
	 * @param dbname
	 * @param username
	 * @param password
	 * @return
	 */
	boolean TestconnectDB(String dbname, String username, String password)
	{
		try
		{
			//I might want to load the driver here
			Class.forName("org.postgresql.Driver");
			
			String url = "jdbc:postgresql:" + dbname;

			// Establish our own connection to database
			// (for verification/testing purposes)
			//System.out.println("Connect to database "+ url + "," + username + "," + password);
			conn = DriverManager.getConnection(url, username, password);

			boolean success = a3.connectDB(url, username, password);
			return success;
		}
		catch (Exception se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}

		return false;
	}
	
	/**
	 * This method is something to keep as well. 
	 * @return
	 */
	boolean TestdisconnectDB()
	{
		try{
			boolean success = a3.disconnectDB();
			return success;

		}catch(Exception e){
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + e.getMessage());
		}

		return false;
	}

	
	boolean TestinsertImplement(){
		
		try
		{
		System.out.println("---------------------------------------------");
		System.out.println("-----------------------------------------------");
		System.out.println("Testing insertImplment() method...");
		
		//int flightNo, String date, int pilot, int plane
		
		// verify from database directly
		Statement stmt = null;
		ResultSet rs = null;
		int flight_count = 0;
		int new_flight_count = 0;
		String queryString;

		float totalScore = 3.0F;
		
		stmt = conn.createStatement();
		queryString = "select count(*) from flightImplementation";
		rs = stmt.executeQuery(queryString);

		if ( rs.next() )
			flight_count = rs.getInt(1);

		//need to verify if the company ID is the company ID from the pilot or not
		System.out.println("Inserting a correct flight implementation");
		boolean success1 = a3.insertImplement(1000, "2008-04-08", 100, 1);
		System.out.println("Return Value: " + success1 + ". The result is correct? " + (success1 == true));
		
		//if the code doesn't accept a correct one, then we don't bother to check with the rest
		if(!success1) {
			//totalScore-=0.25;
			totalScore = 0f;
			TestAssignment3ScoreKeeper.setScore(1, totalScore);
			return false;
		}
		
				
		System.out.println("Inserting a flight with pilot 100 who can't flight plane 7 which is type 4");		
		boolean success3 = a3.insertImplement(1000, "2008-04-08", 100, 7);
		System.out.println("Return Value: " + success3 + ". The result is correct? " + (success3 == false));
		
		if(success3) totalScore-=0.25;
		
		System.out.println("Inserting the same flight");		
		boolean success4 = a3.insertImplement(1000, "2008-04-08", 100, 1);
		System.out.println("Return Value: " + success4 + ". The result is correct? " + (success4 == false));
		
		if(success4) totalScore-=0.25;

		
		System.out.println("Inserting two flights with invalide flight no");		
		boolean success5 = a3.insertImplement(999, "2008-04-08", 100, 1);
		System.out.println("Return Value: " + success5 + ". The result is correct? " + (success5 == false));
				
		if(success5) totalScore-=0.25;

		boolean success6 = a3.insertImplement(1009, "2008-04-08", 100, 1);
		System.out.println("Return Value: " + success6 + ". The result is correct? " + (success6 == false));

		if(success6) totalScore-=0.25;
		
		System.out.println("Inserting two flights with invalide pilot no");		
		boolean success7 = a3.insertImplement(1000, "2008-04-08", 99, 1);
		System.out.println("Return Value: " + success7 + ". The result is correct? " + (success7 == false));
				
		if(success7) totalScore-=0.25;
		
		boolean success8 = a3.insertImplement(1000, "2008-04-08", 128, 1);
		System.out.println("Return Value: " + success8 + ". The result is correct? " + (success8 == false));
		
		if(success8) totalScore-=0.25;
		
		System.out.println("Inserting two flights with invalide plane no");		
		boolean success9 = a3.insertImplement(1000, "2008-04-08", 100, 0);
		System.out.println("Return Value: " + success9 + ". The result is correct? " + (success9 == false));
		
		if(success9) totalScore-=0.25;
		
		boolean success10 = a3.insertImplement(1000, "2008-04-08", 100, 11);
		System.out.println("Return Value: " + success10 + ". The result is correct? " + (success10 == false));

		if(success10) totalScore-=0.25;
		
		System.out.println("Inserting two flights with date not in the future");		
		boolean success11 = a3.insertImplement(1000, "2007-04-08", 100, 1);
		System.out.println("Return Value: " + success11 + ". The result is correct? " + (success11 == false));
				
		if(success11) totalScore-=0.25;
		
		boolean success12 = a3.insertImplement(1000, "2008-01-08", 100, 1);
		System.out.println("Return Value: " + success12 + ". The result is correct? " + (success12 == false));

		if(success12) totalScore-=0.25;
		
		// verify from database directly
		stmt = null;
		rs = null;

		boolean companyNameCorrect = false;
		// verify total no of rows and newly inserted from department table
		stmt = conn.createStatement();
		queryString = "select company from flightImplementation where date='2008-04-08' and flightNo=1000";
		rs = stmt.executeQuery(queryString);

		String companyName = "";
		if ( rs.next() )
			companyName = rs.getString(1);
		
		if(companyName.indexOf("OL")!=-1){
			System.out.println("Company name is correct ["+ companyName + "]");
			companyNameCorrect = true;
		}else{
			System.out.println("Company name is incorrect: " + companyName + ", the correct name is [OL].");
			totalScore-=0.25;
		}
		
		stmt = null;
		rs = null;
		
		stmt = conn.createStatement();
		queryString = "select count(*) from flightImplementation";
		rs = stmt.executeQuery(queryString);

		if ( rs.next() )
			new_flight_count = rs.getInt(1);

		stmt = null;
		rs = null;
		
		System.out.println("The correct response is a total of 1 record is inserted");
		System.out.println("The actual result is a total of " + (new_flight_count - flight_count)+ " records are inserted"); 
		
		if(totalScore < 0) totalScore = 0;
		
		
		//scores[1] = totalScore;
		
		if ( success1 == true && success3 == false && success4 == false 
				&& success5 == false && success6 == false
				&& success7 == false && success8 == false
				&& success9 == false && success10 == false
				&& success11 == false && success12== false && companyNameCorrect == true 
				&& new_flight_count - flight_count == 1){
			
			//before return true, I need to clean up this table 
		
			return true;
		}
		else{
			//if it's not successful, then we write it down
			TestAssignment3ScoreKeeper.setScore(1, totalScore);
			return false;
		}
		
		
		}
		catch (SQLException se)
		{
			System.err.println("SQL Exception in main(). " +
					"<Message>: " + se.getMessage());
		}
		return false;
	}
}	
